Subject: [sami] First SAMI email in the new year, can we go further? Look forward to your opinions.

From: "Yingjie Gu(yingjie)" <[email-masked]>
Date: Thu, 01 Mar 2012 01:16:09 +0000

Hi everyone,
SAMI has been quiet for a long time since last IETF meeting. I was so busy dealing with other issues. Thank you for your continuous interest in SAMI.
Hope we can continue discussion on SAMI in the mail list.

According to previous discussion, one of the arguement is that we don't need State Migration if there is no VM Migration, we can, for example running active-active VMs mechanism to replace VM Migration. Whether VM Migration is a necessary mechanism is not in the scope of State Migration, we had a long discussion at the very beginning of the mail list. But since VM Migration is the precondition of State Migration problem, I would like to make some clarification. I agree that active-active VMs mechanism can support some scenarios, but not all. The problem statement draft is updated and provide two reasons. Here I cited from the draft.

   o   Long lived connections: Some applications may establish
       connections with virtual machines and the connections are kept
       for a long time until the applications disconnect.  One example
       is SQL, SqlConnection.Open() will always try to reuse an existing
       connection instead of creating a new one, and that
       SqlConnection.Close() will often release a connection to the
       connection pool instead of closing it..  The other is HTTP
       persistent connections, also called HTTP keep-alive, or HTTP
       connection reuse.  The idea is to use the same TCP connection to
       send and receive multiple HTTP requests/responses, as opposed to
       opening a new one for every single request/response pair.  Using
       persistent connections is very important for improving HTTP
       performance.  The above examples make it very clear that it's
       unexpectable how long the existing services will be alive, that is
       it's unexpectable how long the old VM need to be kept active.

   o   Hardware failure: While there is hardware problem, it may not
       leave enough time for all the existing services to be
       finished.  For example, there may be a power shortage in a
       particular area, and the DC providers have to move their VMs,
       services and data to another location in limited time.  In this
       case, active-active mechanism may cause services disruption, if
       the existing services on old VMs keep running.

Besides, VM migration has been a widely acknowledged technology and solutions (e.g. VMotion), so I would say we can reasonably assume VM Migration will happen and hence states need to be migrated with VM.

If we get a consensus that VM Migration is a reasonable assumption, I suggest we go to detail of what we can do in IETF to resolve State Migration and how.
But I look forward to your opinions.

Thanks.
________________________________
Best Regards
Gu Yingjie